<?php
/******************************************************************************
Description : vpTransformationen 1.0.1 - classes
Author      : Ingo van Peeren
Urls        : http://www.van-peeren.de
Create date : 2006-06-22
Modified    : 2006-12-18
License     : GNU GPL (see folder "docs/license.txt")
******************************************/

$cfg["tab"]["vpTransformationen"] = $cfg['sql']['sqlprefix'] . "_vpTransformationen";

cInclude('classes', 'class.genericdb.php');

/**
 * Transformation management class
 */
class vpTransformationCollection extends ItemCollection {
	
	/**
	* Constructor Function
	* @param none
	*/
	function vpTransformationCollection() {
		global $cfg;
		parent::ItemCollection($cfg["tab"]["vpTransformationen"], "trid");
		$this->_setItemClass("vpTransformation");
	}

	/**
	* Loads an item by its ID (primary key)
	* @param $itemID integer Specifies the item ID to load
	*/	
	function loadItem ($itemID) {
		$item = new vpTransformation();
		$item->loadByPrimaryKey($itemID);
		return ($item);
	}
	
	/**
	* Loads an item by its ID (primary key)
	* @param $itemID integer Specifies the item ID to load
	*/	
	function loadByLangAndType ($lang, $type = -99) {
		$this->setWhere("language", $lang, "=");
		if ($type <> -99) $this->setWhere("type", $type, "=");
		$this->query();
	}

	/**
	* Creates a new recipient
	* @param $email string specifies the e-mail adress
	* @param $name string specifies the recipient name (optional)
	* @param $confirmed integer specifies, if the recipient is confirmed (optional)
        * @param $joinID string specifies additional recipient group ids to join (optional, e.g. 47,12,...)
	*/		
	function create ($short, $title, $textlong, $type, $lang, $description) {
		global $client, $lang, $auth;
		
		$item = parent::create();
		$item->set("short", $short);
		$item->set("title", $title);
		$item->set("textlong", $textlong);
		$item->set("type", $type);
		$item->set("language", $lang);
		$item->setProperty("transformation", "description", $description);
  		
		$item->store();
		
		return $item;
	}

}

/**
 * Single Transformation Item
 */
class vpTransformation extends Item {
	
	/**
	* Constructor Function
	* @param string $table The table to use as information source
	*/
	function vpTransformation() {
		global $cfg;
		
		parent::Item($cfg["tab"]["vpTransformationen"], "trid");
	}
	
}

?>
