<?php

/******************************************************************************
Description : vpTransformationen 1.0.1 - Backed-Plugin
Author      : Ingo van Peeren
Urls        : http://www.van-peeren.de
Create date : 2006-06-22
Modified    : 2006-12-18
License     : GNU GPL (see folder "docs/license.txt")
******************************************/

cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "widgets/class.widgets.foldingrow.php");
cInclude("classes", "widgets/class.widgets.pager.php");
cInclude("classes", "class.ui.php");
cInclude("classes", "class.properties.php");
cInclude("classes", "class.lang.php");

$plugin_name = "vpTransformationen";

$oPage               = new cPage;
$oEintraege          = new vpTransformationCollection;
$oEintrag            = new vpTransformation;
$sLocation   = $sess->url("main.php?area=$area&frame=$frame");

/* Set default values */
if ((!isset($_REQUEST["elemperpage"]) || !is_numeric($_REQUEST['elemperpage'])) && ($_REQUEST['elemperpage'] != "--all--")) {
	$_REQUEST["elemperpage"] = 25;
}

/* Initialization */
$aFields = array();
$aFields["short"]  	      = array("field" => "short", "caption" => i18n("Kurztext", $plugin_name), "type" => "base,sort,search");
$aFields["textlong"] 	    = array("field" => "textlong", "caption" => i18n("Langtext bzw. URL", $plugin_name), "type" => "base,search");
$aFields["title"] 	      = array("field" => "title", "caption" => i18n("Titel bzw. Sprache", $plugin_name), "type" => "base,search");
$aFields["type"] 	        = array("field" => "type", "caption" => i18n("Typ", $plugin_name), "type" => "base");

$delTitle   = i18n("Transformation l&ouml;schen", $plugin_name);
$delDescr   = i18n("M&ouml;chten Sie diese Transformation wirklich l&ouml;schen:<br>", $plugin_name);

/* Actions folding row */
$oListActionRow = new cFoldingRow("f0d7bf80-e73e-11d9-8cd6-0800200c9a66",i18n("Actions"));

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 0);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Abk&uuml;rzung erstellen", $plugin_name).'</a>');

$sContent  =  '<div style="padding: 4px; padding-left: 12px; border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">'.chr(10);
$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 1);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Akronym erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 2);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Autolink erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 3);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Fremdsprachlichen Begriff erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 5);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Glossar erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 6);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Platzhalter erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

/* Create a link to add a recipient */
$oLink = new cHTMLLink;
$oLink->setMultiLink("vptrans_transformations","","vptrans_transformations","vptransformationen_create");
$oLink->setCustom("type", 4);
$oLink->setContent('<img style="padding-right: 4px;" src="'.$cfg['plugins']['vpTransformationen'] . 'images/trans_add.gif" align="middle">'.i18n("Erkl&auml;rung erstellen", $plugin_name).'</a>');

$sContent .= $oLink->render().'<br />'.chr(10);

$oListActionRow->setContentData($sContent); 

/* List options folding row */

$oListOptionRow = new cFoldingRow("ddc36ef2-25ad-4f3c-ba8f-ee13afccbcc6",i18n("List options"));

$oSelectItemsPerPage = new cHTMLSelectElement("elemperpage");
$oSelectItemsPerPage->autoFill(array("--all--" => i18n("-- All --"), 10 => 10, 25 => 25, 50 => 50, 75 => 75, 100 => 100));
$oSelectItemsPerPage->setDefault($_REQUEST["elemperpage"]);

$oSelectSortBy = new cHTMLSelectElement("sortby");
foreach ($aFields as $sKey => $aData) {
	if (strpos($aData["type"], "sort") !== false) {
		$oOption = new cHTMLOptionElement($aData["caption"], $sKey);
		$oSelectSortBy->addOptionElement($sKey, $oOption);
	}
}	
$oSelectSortBy->setDefault($_REQUEST["sortby"]);

$oSelectSortOrder = new cHTMLSelectElement("sortorder");
$oSelectSortOrder->autoFill(array("asc" => i18n("Ascending"), "desc" => i18n("Descending")));
$oSelectSortOrder->setDefault($_REQUEST["sortorder"]);

$oSelectType = new cHTMLSelectElement("type");
$oOption = new cHTMLOptionElement(i18n("-- All --"), "--all--");
$oSelectType->addOptionElement("all", $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Abk&uuml;rzungen", $plugin_name),0 , 18), 0);
$oOption->setAlt(i18n("Abk&uuml;rzungen", $plugin_name));
$oSelectType->addOptionElement(i18n("Abk&uuml;rzungen", $plugin_name), $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Akronyme", $plugin_name),0 , 18), 1);
$oOption->setAlt(i18n("Akronyme", $plugin_name));
$oSelectType->addOptionElement(i18n("Akronyme", $plugin_name), $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Autolinks", $plugin_name),0 , 18), 2);
$oOption->setAlt(i18n("Autolinks", $plugin_name));
$oSelectType->addOptionElement(i18n("Autolinks", $plugin_name), $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Fremdsprachliche Begriffe", $plugin_name),0 , 18), 3);
$oOption->setAlt(i18n("Fremdsprachliche Begriffe", $plugin_name));
$oSelectType->addOptionElement(i18n("Fremdsprachliche Begriffe", $plugin_name), $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Erkl&auml;rungen", $plugin_name),0 , 18), 4);
$oOption->setAlt(i18n("Erkl&auml;rungen", $plugin_name));
$oSelectType->addOptionElement(i18n("Erkl&auml;rungen", $plugin_name), $oOption);

$oOption = new cHTMLOptionElement(substr(i18n("Platzhalter", $plugin_name),0 , 18), 5);
$oOption->setAlt(i18n("Platzhalter", $plugin_name));
$oSelectType->addOptionElement(i18n("Platzhalter", $plugin_name), $oOption);

$oSelectType->setDefault($_REQUEST["type"]);

$oTextboxFilter = new cHTMLTextbox("filter", $_REQUEST["filter"], 16);

$oSelectSearchIn = new cHTMLSelectElement("searchin");
$oOption = new cHTMLOptionElement(i18n("-- All fields --"), "--all--");
$oSelectSearchIn->addOptionElement("all", $oOption);

foreach ($aFields as $sKey => $aData) {
	if (strpos($aData["type"], "search") !== false) {
		$oOption = new cHTMLOptionElement($aData["caption"], $sKey);
		$oSelectSearchIn->addOptionElement($sKey, $oOption);
	}
}
$oSelectSearchIn->setDefault($_REQUEST["searchin"]);

$oSubmit = new cHTMLButton("submit", i18n("Apply"));

$sContent  = '<div style="border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">'.chr(10);
$sContent .= '<form onsubmit="append_registered_parameters(this);" id="filterform" name="filterform" method="get" action="main.php?1">'.chr(10);
$sContent .= '   <input type="hidden" name="area" value="'.$area.'">'.chr(10);
$sContent .= '   <input type="hidden" name="frame" value="'.$frame.'">'.chr(10);
$sContent .= '   <input type="hidden" name="contenido" value="'.$sess->id.'">'.chr(10);
$sContent .= '   <table>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Type", $plugin_name).'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectType->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10); 
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Items / page").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectItemsPerPage->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Sort by").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSortBy->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Sort order").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSortOrder->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Search for").'</td>'.chr(10);
$sContent .= '         <td>'.$oTextboxFilter->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Search in").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSearchIn->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>&nbsp;</td>'.chr(10);
$sContent .= '         <td>'.$oSubmit->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '    </table>'.chr(10);
$sContent .= '</form>'.chr(10);
$sContent .= '</div>'.chr(10);
$oListOptionRow->setContentData($sContent);

$oEintraege->setWhere("language", $lang);

/* Request data */

if (($_REQUEST["type"] != "") && ($_REQUEST["type"] != "--all--")) {
	$oEintraege->setWhere("type", $_REQUEST["type"]);
} 

$oEintraege->query();

$aDataTable = array();

while ($oEintrag = $oEintraege->next()) {

	$aDataTable[$oEintrag->get("trid")]["id"] = $oEintrag->get("trid");

	foreach ($aFields as $sKey => $aData) {
			if ($sKey == "short") {
				$aDataTable[$oEintrag->get("trid")][$sKey] = $oEintrag->get("short");
			} else {
				$aDataTable[$oEintrag->get("trid")][$sKey] = $oEintrag->get($aData["field"]);
			}
	}
	
	if ($_REQUEST["filter"] != "") {
		if ($_REQUEST["searchin"] == "--all--" || $_REQUEST["searchin"] == "") {
			$found = false;
			
			foreach ($aDataTable[$oEintrag->get("trid")] as $key => $value) {
				if (strpos(strtolower(htmlentities($value)), strtolower(htmlentities($_REQUEST["filter"]))) !== false) {
					$found = true;
				}
			}
			
			if ($found == false) {
				unset($aDataTable[$oEintrag->get("trid")]);
			}			
		} else {
			if (strpos(strtolower(htmlentities($aDataTable[$oEintrag->get("trid")][$_REQUEST["searchin"]])), strtolower(htmlentities($_REQUEST["filter"]))) === false) {
				unset($aDataTable[$oEintrag->get("trid")]);
			}
		}
	}
}

if ($_REQUEST["sortorder"] == "desc") {
	$sortorder = SORT_DESC;	
} else {
	$sortorder = SORT_ASC;
}

$sortby = "short";

$aDataTable = array_csort($aDataTable, $sortby, $sortorder);

/* Content */
$mPage      = $_REQUEST["page"];
$mList      = new UI_Menu;
$iMenu      = 0;
$iItemCount = 0;

if ($mPage == 0) {
	$mPage = 1;	
}

$elemperpage = $_REQUEST["elemperpage"];

#if ($elemperpage == 0) {
#	$elemperpage = 25;
#}

foreach ($aDataTable as $mkey => $params) {
	$id = $params["id"];

	$oLink = new cHTMLLink;
	$oLink->setMultiLink($area, "", $area, "");
	$oLink->setCustom("id", $id);
	$oLink->setAlt($params["textlong"]);
	 
  
	$iItemCount++;
    
	if (($elemperpage == "--all--") || ($iItemCount > ($elemperpage * ($mPage - 1)) && $iItemCount < (($elemperpage * $mPage) + 1))) {    
    		$iMenu++;		
					
		$delete = '<a title="'.$delTitle.'" href="javascript://" onclick="showDelMsg('.$id.',\''.addslashes($params["short"]).'\')"><img src="'.$cfg['path']['images'].'delete.gif" border="0" title="'.$delTitle.'" alt="'.$delTitle.'"></a>';

           $tipe0 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_abkuerzung.gif" alt="'.i18n("Abk&uuml;rzung").'" title="'.i18n("Abk&uuml;rzung").'" />';	
			$tipe1 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_akronym.gif" alt="'.i18n("Akronym").'" title="'.i18n("Akronym").'" />';
			$tipe2 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_autolink.gif" alt="'.i18n("Autolink").'" title="'.i18n("Autolink").'" />';
			$tipe3 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_fremdsprachlich.gif" alt="'.i18n("fremdsprachlicher Begriff").'" title="'.i18n("fremdsprachlicher Begriff").'" />';
			$tipe4 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_erklaerung.gif" alt="'.i18n("Erkl&auml;rung").'" title="'.i18n("Erkl&auml;rung").'" />';
			$tipe5 ='<img src="'.$cfg['plugins']['vpTransformationen'].'images/type_platzhalter.gif" alt="'.i18n("Platzhalter").'" title="'.i18n("Platzhalter").'" />';
			
			$tipe = $params["type"];
			
			if ($tipe == '0') {
				$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_abkuerzung.gif');
               // $mList->setActions($iMenu, "tipe", $tipe0);
		//		$oLink->updateAttributes(array ("title" => i18n("Abkrzung")));				
				}
			else {
			   if ($tipe == '1') {
			   $mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_akronym.gif');			   	
				// $mList->setActions($iMenu, "tipe", $tipe1); 
				}
			else {
			 if ($tipe == '2') {
			 	$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_autolink.gif');
				// $mList->setActions($iMenu, "tipe", $tipe2); 
				}
			else {
			 if ($tipe == '3') {
			 	$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_fremdsprachlich.gif');
				// $mList->setActions($iMenu, "tipe", $tipe3); 
				}
		   	else {
			 if ($tipe == '5') {
			 	$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_glossarlink.gif');
				// $mList->setActions($iMenu, "tipe", $tipe3); 
				}
			else {
			 if ($tipe == '6') {
			 	$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_platzhalterlink.gif');
				// $mList->setActions($iMenu, "tipe", $tipe3); 
				}
			else if ($tipe == '4') {
				$mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] .'images/type_erklaerung.gif');
				// $mList->setActions($iMenu, "tipe", $tipe4); 
			}
			}
			}
			}
			}
			}			 
					
			$mList->setTitle($iMenu, wordwrap($params["short"], 20, "<br />\n" ));
	    	$mList->setLink($iMenu, $oLink);		
	    	$mList->setActions($iMenu, "delete", $delete); 						
	    	// $mList->setImage($iMenu, $cfg['plugins']['vpTransformationen'] . 'images/trans.gif');
			
	}
}

$oPagerLink = new cHTMLLink;
$oPagerLink->setLink("main.php");
$oPagerLink->setCustom("elemperpage", $elemperpage);
$oPagerLink->setCustom("filter", $_REQUEST["filter"]);
$oPagerLink->setCustom("sortby", $_REQUEST["sortby"]);
$oPagerLink->setCustom("sortorder", $_REQUEST["sortorder"]);
$oPagerLink->setCustom("searchin", $_REQUEST["searchin"]);
$oPagerLink->setCustom("frame", $frame);
$oPagerLink->setCustom("area", $area);
$oPagerLink->enableAutomaticParameterAppend();
$oPagerLink->setCustom("contenido", $sess->id);

if ($elemperpage == "--all--") $elemperpage = 10000;

$oPager     = new cObjectPager("0ed6d632-6adf-4f09-a0c6-1e38ab60e301", $iItemCount, $elemperpage, $mPage, $oPagerLink, "page");

$execScript = '
    <script type="text/javascript">       
        /* Session-ID */
        var sid = "'.$sess->id.'";

        /* Create messageBox instance */
        box = new messageBox("", "", "", 0, 0);

        function showDelMsg(lngId, strElement) {
            box.confirm("'.$delTitle.'", "'.$delDescr.'<b>" + strElement + "</b>", "deleteTransformation(\'" + lngId + "\')");
        }

        /* Function for deleting recipients */
        function deleteTransformation(id) {
            oForm = document.getElementById("filterform");

            url  = "main.php?area=vptrans_transformations";
            url += "&action=vptransformationen_delete";
            url += "&frame=4";
            url += "&id=" + id;
            url += "&contenido=" + sid;
            url += get_registered_parameters();
            url += "&sortby=" + oForm.sortby.value;
            url += "&sortorder=" + oForm.sortorder.value;
            url += "&filter=" + oForm.filter.value;
            url += "&elemperpage=" + oForm.elemperpage.value;

            parent.parent.right.right_bottom.location.href = url;
        }
		</script>';

$oPage->setMargin(0);
$oPage->addScript('messagebox', '<script type="text/javascript" src="scripts/messageBox.js.php?contenido='.$sess->id.'"></script>');
$oPage->addScript('delete', $execScript);
$oPage->addScript('cfoldingrow.js', '<script language="JavaScript" src="scripts/cfoldingrow.js"></script>');
$oPage->addScript('parameterCollector.js', '<script language="JavaScript" src="scripts/parameterCollector.js"></script>');

$oPage->setContent(array('<table border="0" cellspacing="0" cellpadding="0" width="100%">', $oListActionRow, $oListOptionRow, $oPager, '</table>', $mList->render(false)));
$oPage->render();

unset ($plugin_name);
?>
