<?php

/******************************************************************************
Description : vpTransformationen 1.0.1 - Backed-Plugin
Author      : Ingo van Peeren
Urls        : http://www.van-peeren.de
Create date : 2006-06-22
Modified    : 2006-12-18
License     : GNU GPL (see folder "docs/license.txt")
******************************************/

cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "widgets/class.widgets.datawidgets.php");
cInclude("classes", "class.ui.php");
cInclude("classes", "class.htmlelements.php");
cInclude("classes", "class.properties.php");
cInclude("classes", "class.lang.php");
cInclude("classes", "contenido/class.client.php");

$plugin_name = "vpTransformationen";

$oPage               = new cPage;

$oClient = new cApiClient($client);

if ($perm->have_perm_area_action("vptrans_preferences", "vptransformationen_prefs_save")) {
	$oForm = new UI_Table_Form("properties");
	$oForm->setVar("frame", $frame);
	$oForm->setVar("area", $area);
	$oForm->setVar("action", "vptransformationen_prefs_save");
	$oForm->setVar("set", $_REQUEST["set"]);
		
	switch ($_REQUEST["set"]) {
  case "acronym":
    $oForm->addHeader(i18n("Akronym-Verhalten", $plugin_name));
    
    if (($action == "vptransformationen_prefs_save") && ($acronym != "")) {
      $oClient->setProperty("vptrans", "acronym-behavior", $acronym);
    }
    
    $sValue = $oClient->getProperty("vptrans", "acronym-behavior");
    
    $oSelectAcronym = new cHTMLSelectElement("acronym");

    $oOption = new cHTMLOptionElement(i18n("alle ersetzen", $plugin_name), "all");
    $oSelectAcronym->addOptionElement(i18n("alle ersetzen", $plugin_name), $oOption);

    $oOption = new cHTMLOptionElement(i18n("erstes Vorkommen ersetzen", $plugin_name), "first");
    $oSelectAcronym->addOptionElement(i18n("erstes Vorkommen ersetzen", $plugin_name), $oOption);

    $oOption = new cHTMLOptionElement(i18n("EfA-Methode", $plugin_name), "efa");
    $oSelectAcronym->addOptionElement(i18n("EfA-Methode", $plugin_name), $oOption);

    $oSelectAcronym->setDefault($sValue);
	  
	  $oForm->add(i18n("Verhalten", $plugin_name),     $oSelectAcronym->render());
	  
    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("alle ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung alle ersetzen", $plugin_name));
    $sDL .= $oP->render(); 
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oP->render();
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("EfA-Methode", $plugin_name));
    $sDL .= $oH4->render(); 

    $oLink = new cHTMLLink("http://www.einfach-fuer-alle.de/artikel/abkuerzungen/");
    $oLink->_setContent("www.einfach-fuer-alle.de/artikel/abkuerzungen/");
    $oLink->setAttribute("target", "_blank");
    $sLink .= $oLink->render();
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung EfA-Methode", $plugin_name) . "<br><br>" . $sLink);
    $sDL .= $oP->render();               
    
    $sExpl .= $sDL;  
    	  
  break;
  
  case "link":
    $oForm->addHeader(i18n("Link-Verhalten", $plugin_name));
    
    if (($action == "vptransformationen_prefs_save") && ($link != "")) {
      $oClient->setProperty("vptrans", "link-behavior", $link);
    }
    
    $sValue = $oClient->getProperty("vptrans", "link-behavior");
    
    $oSelectLink = new cHTMLSelectElement("link");

    $oOption = new cHTMLOptionElement(i18n("alle ersetzen", $plugin_name), "all");
    $oSelectLink->addOptionElement("all", $oOption);

    $oOption = new cHTMLOptionElement(i18n("erstes Vorkommen ersetzen", $plugin_name), "first");
    $oSelectLink->addOptionElement("first", $oOption);

    $oSelectLink->setDefault($sValue);
	  
	  $oForm->add(i18n("Verhalten", $plugin_name),     $oSelectLink->render());
	  
    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("alle ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung alle ersetzen", $plugin_name));
    $sDL .= $oP->render(); 
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oP->render();            
    
    $sExpl .= $sDL;	  
	  
  break;
  
  case "explanation":
    $oForm->addHeader(i18n("Erklrungs-Verhalten", $plugin_name));
    
    if (($action == "vptransformationen_prefs_save") && ($explanation != "")) {
      $oClient->setProperty("vptrans", "explanation-behavior", $explanation);
    }
    
    $sValue = $oClient->getProperty("vptrans", "explanation-behavior");
    
    $oSelectExplanation = new cHTMLSelectElement("explanation");

    $oOption = new cHTMLOptionElement(i18n("alle ersetzen", $plugin_name), "all");
    $oSelectExplanation->addOptionElement(i18n("alle ersetzen", $plugin_name), $oOption);

    $oOption = new cHTMLOptionElement(i18n("erstes Vorkommen ersetzen", $plugin_name), "first");
    $oSelectExplanation->addOptionElement(i18n("erstes Vorkommen ersetzen", $plugin_name), $oOption);

    $oSelectExplanation->setDefault($sValue);
	  
	  $oForm->add(i18n("Verhalten", $plugin_name),     $oSelectExplanation->render());
	  
    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("alle ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung alle ersetzen", $plugin_name));
    $sDL .= $oP->render(); 
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung erstes Vorkommen ersetzen", $plugin_name));
    $sDL .= $oP->render();              
    
    $sExpl .= $sDL;
	  
  break;
  
  case "match":
    $oForm->addHeader(i18n("Gro&szlig;-/Kleinschreibung", $plugin_name));
    
    if (($action == "vptransformationen_prefs_save") && ($match != "")) {
      $oClient->setProperty("vptrans", "exact_match", $match);
    }
    
    $sValue = $oClient->getProperty("vptrans", "exact_match");
    
    $oSelectMatch = new cHTMLSelectElement("match");

    $oOption = new cHTMLOptionElement(i18n("beachten", $plugin_name), "true");
    $oSelectMatch->addOptionElement(i18n("beachten", $plugin_name), $oOption);

    $oOption = new cHTMLOptionElement(i18n("nicht beachten", $plugin_name), "false");
    $oSelectMatch->addOptionElement(i18n("nicht beachten", $plugin_name), $oOption);

    $oSelectMatch->setDefault($sValue);
	  
	  $oForm->add(i18n("Verhalten"),     $oSelectMatch->render());
	  
    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("Gro&szlig;-/Kleinschreibung", $plugin_name) . " " . i18n("beachten", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung Gro&szlig;-/Kleinschreibung beachten", $plugin_name));
    $sDL .= $oP->render(); 
    
    $oH4 = new cHTML();
    $oH4->_tag = "h4"; 
    $oH4->_setContent(i18n("Gro&szlig;-/Kleinschreibung", $plugin_name) . " " . i18n("nicht beachten", $plugin_name));
    $sDL .= $oH4->render(); 
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung Gro&szlig;-/Kleinschreibung nicht beachten", $plugin_name));
    $sDL .= $oP->render();              
    
    $sExpl .= $sDL;	  
	  
  break;
  
  case "languages":
    $oForm->addHeader(i18n("Sprachen", $plugin_name));
    $lg = $_REQUEST["lg"];
    
    if (($action == "vptransformationen_prefs_save") && (is_array($lg)) && (count($lg))) {
      $languages = implode(" ", $lg);
      $oClient->setProperty("vptrans", "languages", $languages);
    }
    
    $sLanguages = $oClient->getProperty("vptrans", "languages");
    $aLanguages = explode(" ", $sLanguages);
    
    $sAllLanguages = "aa ab af am ar as ay az ba be bg bh bi bn bo br ca co cs cy da de dz el en eo es et eu fa fi fj fo fr fy ga gd gl gn gu ha he hi hr hu hy ia id ie ik is it iu iw ja ji jv ka kk kl km kn ko ks ku ky la ln lo lt lv mg mi mk ml mn mo mr ms mt my na ne nl no oc om or pa pl ps pt qu rm rn ro ru rw sa sd sg sh si sk sl sm sn so sq sr ss st su sv sw ta te tg th ti tk tl tn to tr ts tt tw ug uk ur uz vi vo wo xh yi yo za zh zu";
    $aAllLanguages = explode(" ", $sAllLanguages);
    
    $sCheckboxes = '<div style="line-height: 2.5">';
    $i = 0;
    
    foreach ($aAllLanguages AS $lang) {
      $oCheckLanguage = new cHTMLCheckbox('lg["' . $lang . '"]', $lang, 'lg["' . $lang . '"]');
      //$oCheckLanguage->attachStyleDefinition("float", "float: left;");
      if (in_array($lang, $aLanguages)) $oCheckLanguage->setChecked(true);
      $oLabel = new cHTMLLabel($lang, 'lg["' . $lang . '"]');
      $sCheckboxes .= $oCheckLanguage->toHtml(false);
      $sCheckboxes .= $oLabel->render();
      $i++;
      if ($i % 15 == 0) $sCheckboxes .= '<br style="clear: both;">';;      
    }
    
    $sCheckboxes .= '<br style="clear: both;"></div>';
    
    $oForm->add(i18n("auswhlen", $plugin_name),     $sCheckboxes);

    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();

    $oLink = new cHTMLLink("http://de.selfhtml.org/diverses/sprachenkuerzel.htm#uebersicht_iso_639_1");
    $oLink->_setContent("de.selfhtml.org/diverses/sprachenkuerzel.htm#uebersicht_iso_639_1");
    $oLink->setAttribute("target", "_blank");
    $sLink .= $oLink->render();
    
    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung Sprachen einrichten", $plugin_name) . "<br><br>" . $sLink);
    $sDL .= $oP->render();              
    
    $sExpl .= $sDL;	

  break;
  
  case "classes":
  
    $oForm->addHeader(i18n("CSS-Klassen", $plugin_name));
    
    if ($action == "vptransformationen_prefs_save") {
      if ($externallink != "") $oClient->setProperty("vptrans", "externallink-class", $externallink);
      else $oClient->setProperty("vptrans", "externallink-class", "externallink");
      
      if ($externallink != "") $oClient->setProperty("vptrans", "abbr-class", $abbr);
      else $oClient->setProperty("vptrans", "abbr-class", "abbr");
      
      if ($externallink != "") $oClient->setProperty("vptrans", "language-class", $language);
      else $oClient->setProperty("vptrans", "language-class", "language");
      
      if ($externallink != "") $oClient->setProperty("vptrans", "explanation-class", $explanation);
      else $oClient->setProperty("vptrans", "explanation-class", "explanation");
    }
    
    $sExternallinkClass = $oClient->getProperty("vptrans", "externallink-class");
    if ($sExternallinkClass == "") $sExternallinkClass = "externallink";
    $sAbbrClass = $oClient->getProperty("vptrans", "abbr-class");
    if ($sAbbrClass == "") $sAbbrClass = "abbr";
    $sLanguageClass = $oClient->getProperty("vptrans", "language-class");
    if ($sLanguageClass == "") $sLanguageClass = "language";
    $sExplanationClass = $oClient->getProperty("vptrans", "explanation-class");
    if ($sExplanationClass == "") $sExplanationClass = "explanation";
    
    $oExternallink    = new cHTMLTextbox("externallink", $sExternallinkClass, 110);
    $oAbbr    = new cHTMLTextbox("abbr", $sAbbrClass, 110);
    $oLanguage    = new cHTMLTextbox("language", $sLanguageClass, 110);
    $oExplanation    = new cHTMLTextbox("explanation", $sExplanationClass, 110);
    
	  $oForm->add(i18n("Externe Links", $plugin_name),    $oExternallink->render());
	  $oForm->add(i18n("Abk&uuml;rzungen (&lt;ABBR&gt;)", $plugin_name),  $oAbbr->render());
	  $oForm->add(i18n("Fremdsprachliche Begriffe", $plugin_name),  $oLanguage->render());
	  $oForm->add(i18n("Erkl&auml;rungen", $plugin_name),  $oExplanation->render());

    $oHead = new cHTML();
    $oHead->_tag = "h3";
    $oHead->_setContent(i18n("Erl&auml;uterungen", $plugin_name));
    
    $sExpl = $oHead->render();

    $oP = new cHTML();
    $oP->_tag = "p"; 
    $oP->_setContent(i18n("Ekl&auml;rung CSS-Klassen einrichten", $plugin_name));
    $sDL .= $oP->render();              
    
    $sExpl .= $sDL;

  break;  
}
	
	$sContent .= $oForm->render(true);
	$sContent .= $sExpl;
	
	$oPage->setContent($notis . $sContent);
	
} else {
	$oPage->setContent($notis . "");	
}

$execScript = '<script type="text/javascript">
	
			/* Check if we are in a dual-frame or a quad-frame */
			if ( parent.parent.frames[0].name == "header")
			{
	    		if ( parent.frames["right_top"].document.getElementById("c_0") ) {
	                menuItem = parent.frames["right_top"].document.getElementById("c_0");
	                parent.frames["right_top"].sub.click(menuItem);
	            } 	
			} else {
	        /* Check if submenuItem is existing
	           and mark it */
			
	            if ( parent.parent.frames["right"].frames["right_top"].document.getElementById("c_0") ) {
	                menuItem = parent.parent.frames["right"].frames["right_top"].document.getElementById("c_0");
	                parent.parent.frames["right"].frames["right_top"].sub.click(menuItem);
	            } 
			}
		</script>';

$oPage->addScript('changeview', $execScript);

$oPage->render();

unset ($plugin_name);
?>
